<template>
  <RimowSelectize
    :placeholder="parameter.placeholder"
    :add-properties="addProperties(parameter, HTMLSelectElement)"
    item-icon="antenna-bars-1"
    :multiple="true"
    :selected="selected"
    :options="dropdownOptions"
    :disabled="disabled"
    @change="updateMultiselect"
  />
</template>

<script>
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
      HTMLSelectElement: null,
    };
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
    selected() {
      if (this.param.value) {
        const vals = this.param.value.split(',');
        return this.dropdownOptions.filter((opt) => {
          return vals.includes(opt.id);
        });
      }
      return undefined;
    },
    dropdownOptions() {
      const separator = this.parameter.options.delimiter;
      return this.parameter.options.values.map((opt) => {
        const [value, tag] = opt.toString().split(separator);
        return {
          id: value,
          title: value,
          description: tag,
        };
      });
    },
  },
  mounted() {
    this.HTMLSelectElement = HTMLSelectElement;
  },
  methods: {
    async updateMultiselect(value) {
      if (this.disabled) return;
      const newValue = value.map((opt) => opt.id).join(',');
      await this.updateValue(this.parameter.key, newValue);
    },
  },
};
</script>
